#ifndef RANDOM_GETTER_HPP
#define RANDOM_GETTER_HPP

#include <string>
#include <random>

#include "getter.hpp"

class RandomCharacterGetter : public Getter
{
    static const std::string ALPHANUM;

public:
    RandomCharacterGetter();

    char operator ()() override;

private:
    size_t _getIndex();

    std::random_device randomDevice_;
    std::mt19937 generator_;
    std::uniform_int_distribution<size_t> distribution_;
};

#endif // RANDOM_GETTER_HPP
