#include "slow_copy.hpp"

#include <chrono>
#include <thread>

SlowCopy::SlowCopy(PutterPtr dst, GetterPtr src)
: dst_(dst)
, src_(src)
{
}

void SlowCopy::operator()()
{
    while (1)
    {
        _wait();
        char character = (*src_)();

         if (character == 'x') break;
            
        dst_->put(character);
    }
}

void SlowCopy::_wait()
{
    int msWait = 100;
    std::this_thread::sleep_for(std::chrono::milliseconds(msWait));
}
