#include <iostream> 

#include "dynamic/keyboard_getter.hpp"
#include "dynamic/random_getter.hpp"
#include "dynamic/console_putter.hpp"
#include "dynamic/slow_copy.hpp"

struct PutterFactory
{
    PutterPtr operator()()
    {
        return std::make_shared<ConsolePutter>();
    }
};

struct GetterFactory
{
    GetterPtr operator()()
    {
       // return std::make_shared<KeyboardGetter>();
        return std::make_shared<RandomCharacterGetter>();
    }
};

int main(void)
{
    std::cout << "wyklad 9 " << std::endl;

    auto getter = GetterFactory()();
    auto putter = PutterFactory()();

    SlowCopy(putter, getter)();

    std::cout << std::endl;
    return 0;
}
